Pi2 + ADFFS

Discuss development specific to the Pi version of ADFFS
Post Reply
morb
Posts: 8
Joined: Wed Jan 28, 2015 11:57 pm

Pi2 + ADFFS

Post by morb » Sun Mar 27, 2016 11:28 pm

Hello all,

So I'm writing this from RISC OS running very nicely on a Pi, a pleasant experience all told.

What combination of factors do I need to run games, though, I wonder? -- The Pi in question is a Version 2 Model B+. I downloaded the Pi-ready RISC OS SD image, which tells me it's version 5.21, dated 17 Feb 2015. I can see that there are newer versions available which make substantial changes to the way memory is addressed (changes I imagine to be driven in part or whole by ADFFS development) but it's not clear to me how I would create an SD disc image to run these newer builds (nor that it's necessary for me to do so!)

As for ADFFS itself, I've tried version 2.50b without success, but that doesn't surprise me too much given what I'm reading in this subforum about Pi2 development being ongoing.

So the questions that arise are these:
Are there more recent dev builds available, would they help, and from where could I obtain them?
Would I be best advised to stick with RISC OS 5.21, or try something newer (and if so, how?)

Cheers,
morb.

JonAbbott
Posts: 1736
Joined: Thu Apr 11, 2013 12:13 pm
Location: Essex

Re: Pi2 + ADFFS

Post by JonAbbott » Mon Mar 28, 2016 6:44 am

None of the currently released builds are Pi2 compatible, we're currently testing the build that will be on the Pi1, to ensure there's no bugs in the unaligned abort handler.

However, quite a few games fail in odd ways on the Pi2 and I've yet to track down why. It can only be down to deprecated instructions, or instruction sequences that trigger erratum, as ADFFS was recoded to use the RISCOS cache and TLB ARMOps and is working on the Pi1 in ARMv6 strict mode. Another odd thing I'm seeing is GPU memory corruption in the screen boarders, these aren't being blitted from the game and are being erased every frame and yet the corruption seems to remain and isn't overwritten when the frame is blanked.

The next build will be released as soon as the last few bugs are ironed out, hopefully next month. As for OS requirements, the next release requires a High Vector build of RISCOS 5.23 dated after Oct 30th 2015 (ie a reasonably current official nightly build)

Regarding your question about how to upgrade past 5.21, simply download a Pi nightly build, extract the "riscos" ROM file, rename it to RISCOS/IMG and overwrite !Boot.Loader.RISCOS/IMG

Post Reply